/**
 ******************************************************************************
 * @project  potentialmeter sensor example
 * @author   Edward Ahn, Jim Jun
 * @version  V1.0.1
 * @date     26-MAY-2016
 * @brief    Analog input
*******************************************************************************
**/

/*
  아두이노 M0의 아날로그 변환기는 12비트 해상도를 가지므로 0에서
  4095 사이의 값을 반환한다. 기준 전압은 디폴트로 전원 전압인 3.3V를 사용하였으므로
  0V에서 3.3V 사이의 전압이 0에서 1023의 디지털 값으로 변환되어 입력된다.
  
  가변 저항을 돌려 0V에 가까워질수록 0에 가까운 값을, 3.3V에 가까워질수록 1023에 가까운
  값이 출력됨을 확인할 수 있다.
*/
const int sensorPin = A0; // 가변 저항 A0 선언
const int ledPin = 13; // LED D13 선언     
int val = 0;  // 가변저항 값을 읽은값을 저장할 변수 선언
int aout = 0;

void setup() {
  pinMode(ledPin, OUTPUT); // LED 출력으로 지정

  // Open serial communications and wait for port to open:
  SerialUSB.begin(9600);
  while (!SerialUSB) {
    ; // wait for serial port to connect. Needed for Leonardo only
  }
}

void loop() {
  val = analogRead(sensorPin); // 가변 저항 값 읽기
  /*
  if(val > 512){ // 읽은 값이 512보다 크면 LED OFF
    digitalWrite(ledPin, LOW); 
  }
  else{ // 읽은 값이 512보다 작으면 LED ON
    digitalWrite(ledPin, HIGH);
  } 
  */
  aout = map(val,0,1023,0,255);
  analogWrite(ledPin, aout);
  SerialUSB.println(val);
  SerialUSB.println(aout);
  delay(50);
}
